
#include <vector>
#include <array>

/**
 *
 * Pid for PbPb @ 30A GeV obtained using TShine framework
 */

const std::vector<double> vmom = {
    0.193479,
    0.213828,
    0.236316,
    0.26117,
    0.288637,
    0.318993,
    0.352542,
    0.389619,
    0.430596,
    0.475882,
    0.525931,
    0.581244,
    0.642374,
    0.709933,
    0.784597,
    0.867114,
    0.958309,
    1.0591,
    1.17048,
    1.29358,
    1.42963,
    1.57998,
    1.74615,
    1.9298,
    2.13276,
    2.35706,
    2.60495,
    2.87892,
    3.1817,
    3.51632,
    3.88613,
    4.29484,
    4.74654,
    5.24573,
    5.79743,
    6.40715,
    7.081,
    7.82571,
    8.64875,
    9.55835,
    10.5636,
    11.6746,
    12.9024,
    14.2594,
    15.7591,
    17.4164,
    19.2481,
    21.2725,
    23.5097,
    25.9823,
    28.7149
};
//     const TAxis amom( pid::vmom.size()-1, &(pid::vmom[0]) );

const std::vector<std::array<float, 9> > pos =
    {
        {1.49, -1, 0.146184, 0.815, 1.335, 0.988287, -1, -1, 0},
        {1.36, -1, 0.660956, 0.864999, 1.29, 0.988922, -1, -1, 0},
        {1.345, -1, 0.658706, 0.844999, 1.27, 0.982934, -1, -1, 0},
        {1.325, -1, 0.636636, 0.835, 1.25, 0.980861, -1, -1, 0},
        {1.31, -1, 0.713671, 0.8, 1.23, 0.968091, -1, -1, 0},
        {1.29, 1.45, 0.728072, 0.79, 1.215, 0.96987, -1, -1, 0},
        {1.275, 1.43, 0.742057, 0.78, 1.195, 0.963176, -1, -1, 0},
        {1.26, 1.415, 0.761192, 0.77, 1.185, 0.967857, -1, -1, 0},
        {1.245, 1.395, 0.767734, 0.76, 1.17, 0.967238, -1, -1, 0},
        {1.23, 1.385, 0.792182, 0.75, 1.155, 0.965035, -1, -1, 0},
        {1.21, 1.38, 0.839572, 0.745, 1.145, 0.968694, -1, -1, 0},
        {1.195, 1.4, 0.897731, 0.735, 1.13, 0.964164, -1, -1, 0},
        {1.18, 1.4, 0.91006, 0.72, 1.115, 0.956675, -1, -1, 0},
        {1.17, 1.4, 0.909758, 0.705, 1.105, 0.955217, -1, -1, 0},
        {1.155, 1.39, 0.914351, 0.69, 1.09, 0.945211, -1, -1, 0},
        {1.145, 1.38, 0.908917, 0.68, 1.07, 0.922527, -1, -1, 0},
        {1.145, 1.37, 0.87798, 0.675, 1.03, 0.832131, -1, -1, 0},
        {1.14, 1.355, 0.854891, 0.67, 0.984999, 0.661343, -1, -1, 0},
        {1.13, 1.345, 0.841502, 0.66, 0.964999, 0.574563, -1, -1, 0},
        {1.12, 1.335, 0.824558, 0.655, 0.944999, 0.474886, -1, -1, 0},
        {1.11, 1.325, 0.806278, 0.65, 0.924999, 0.37095, -1, -1, 0},
        {1.1, 1.315, 0.786032, 0.65, 0.899999, 0.238823, -1, -1, 0},
        {1.09, 1.305, 0.762476, 0.645, 0.859999, 0.0893542, -1, -1, 0},
        {1.085, 1.295, 0.702193, 0.64, 0.77, 0.00316389, -1, -1, 0},
        {1.08, 1.28, 0.620815, -1, -1, 0, -1, -1, 0},
        {1.06, 1.27, 0.616457, -1, -1, 0, -1, -1, 0},
        {1.045, 1.265, 0.625515, -1, -1, 0, -1, -1, 0},
        {1.015, 1.255, 0.715664, -1, -1, 0, 0.605, 0.815, 0.0667911},
        {0.984999, 1.2, 0.794903, -1, -1, 0, 0.6, 0.815, 0.0843162},
        {0.969999, 1.135, 0.733805, -1, -1, 0, 0.585, 0.8, 0.0849407},
        {0.944999, 1.12, 0.783706, -1, -1, 0.429882, 0.58, 0.795, 0.118049},
        {0.929999, 1.14, 0.844255, -1, -1, 0.447605, 0.575, 0.785, 0.122542},
        {0.884999, 1.15, 0.917326, -1, -1, 0, 0.55, 0.735, 0.0700617},
        {0.859999, 1.145, 0.93484, -1, -1, 0, 0.535, 0.7, 0.0426673},
        {0.82, 1.175, 0.968438, -1, -1, 0, 0.52, 0.645, 0.0150096},
        {0.79, 1.175, 0.979235, -1, -1, 0, 0.51, 0.61, 0.008769},
        {0.705, 1.16, 0.993161, -1, -1, 0, -1, -1, 0},
        {0.57, 1.12, 0.98564, -1, -1, 0, -1, -1, 0},
        {0.565, 1.12, 0.987778, -1, -1, 0, -1, -1, 0},
        {0.565, 1.12, 0.988327, -1, -1, 0, -1, -1, 0},
        {0.56, 1.15, 0.995113, -1, -1, 0, -1, -1, 0},
        {0.565, 1.145, 0.992986, -1, -1, 0, -1, -1, 0},
        {0.57, 1.145, 0.990373, -1, -1, 0, -1, -1, 0},
        //{0.844999, 1.095, 0.883701, -1, -1, 0, 0.525, 0.665, 0.0367248},
        {0.844999, 1.095, 0.883701, -1, -1, 0, -1, -1, 0.0367248},
        {0.815, 1.145, 0.947759, -1, -1, 0, -1, -1, 0},
        {0.735, 1.16, 0.969021, -1, -1, 0, -1, -1, 0},
        {0.63, 1.165, 0.939684, -1, -1, 0, -1, -1, 0},
        {0.6, 1.19, 0.914233, -1, -1, 0, -1, -1, 0},
        {0.59, 1.21, 0.811614, -1, -1, 0, -1, -1, 0},
        {4.56473e-41, 4.59163e-41, 0, 0, 0, 4.56473e-41, 0, 0, 0}

    };
const std::vector<std::array<float, 9> > neg =
    {
        {1.33, -1, 0.787825, -1, -1, 0, -1, -1, 0},
        {1.315, -1, 0.841236, -1, -1, 0, 1.05, 1.19, 0.201529},
        {1.295, -1, 0.864117, -1, -1, 0, 1.015, 1.17, 0.198001},
        {1.295, 1.49, 0.841675, -1, -1, 0, 1.08, 1.17, 0.221194},
        {1.285, 1.47, 0.835603, -1, -1, 0, 1.07, 1.16, 0.239684},
        {1.275, 1.445, 0.825176, -1, -1, 0, 1.02, 1.16, 0.324708},
        {1.26, 1.485, 0.880087, -1, -1, 0, 0.944999, 1.16, 0.401554},
        {1.25, 1.465, 0.880123, -1, -1, 0, 0.929999, 1.15, 0.41367},
        {1.24, 1.45, 0.880278, -1, -1, 0, 0.914999, 1.145, 0.472261},
        {1.225, 1.44, 0.896573, -1, -1, 0, 0.899999, 1.135, 0.487872},
        {1.215, 1.43, 0.895126, -1, -1, 0, 0.884999, 1.125, 0.50415},
        {1.205, 1.415, 0.893119, -1, -1, 0, 0.869999, 1.115, 0.515771},
        {1.195, 1.405, 0.890825, -1, -1, 0, 0.854999, 1.105, 0.527113},
        {1.18, 1.39, 0.89922, -1, -1, 0, 0.839999, 1.09, 0.505367},
        {1.17, 1.38, 0.894782, -1, -1, 0, 0.83, 1.08, 0.512005},
        {1.16, 1.37, 0.887214, -1, -1, 0, 0.815, 1.065, 0.487937},
        {1.145, 1.36, 0.894466, -1, -1, 0, 0.8, 1.055, 0.496116},
        {1.135, 1.35, 0.886342, -1, -1, 0, 0.785, 1.04, 0.469697},
        {1.125, 1.345, 0.875759, -1, -1, 0, 0.77, 1.025, 0.445818},
        {1.115, 1.33, 0.858896, -1, -1, 0, 0.755, 1.01, 0.423985},
        {1.1, 1.325, 0.860414, -1, -1, 0, 0.735, 0.994999, 0.401784},
        {1.09, 1.31, 0.84033, -1, -1, 0, 0.72, 0.979999, 0.378425},
        {1.08, 1.305, 0.818917, -1, -1, 0, 0.705, 0.959999, 0.326549},
        {1.065, 1.295, 0.815094, -1, -1, 0, 0.69, 0.939999, 0.275787},
        {1.055, 1.285, 0.792423, -1, -1, 0, 0.68, 0.919999, 0.223679},
        {1.045, 1.275, 0.768402, -1, -1, 0, 0.665, 0.899999, 0.174586},
        {1.04, 1.265, 0.716269, -1, -1, 0, 0.65, 0.869999, 0.103629},
        {1.01, 1.25, 0.784039, -1, -1, 0, 0.63, 0.859999, 0.152136},
        {0.989999, 1.24, 0.796408, -1, -1, 0, 0.61, 0.835, 0.129478},
        {0.969999, 1.23, 0.812625, -1, -1, 0, 0.59, 0.81, 0.113368},
        {0.944999, 1.22, 0.842636, -1, -1, 0, 0.565, 0.785, 0.105586},
        {0.924999, 1.205, 0.860119, -1, -1, 0, 0.55, 0.765, 0.102548},
        {0.904999, 1.195, 0.877486, -1, -1, 0, 0.53, 0.745, 0.0976804},
        {0.884999, 1.185, 0.89337, -1, -1, 0, 0.515, 0.725, 0.0902046},
        {0.864999, 1.175, 0.908095, -1, -1, 0, 0.5, 0.705, 0.0814904},
        {0.844999, 1.165, 0.92098, -1, -1, 0, 0.485, 0.685, 0.0767336},
        {0.83, 1.155, 0.932738, -1, -1, 0, 0.48, 0.67, 0.0677157},
        {0.56, 1.125, 0.987318, -1, -1, 0, -1, -1, 0},
        {0.56, 1.13, 0.990822, -1, -1, 0, -1, -1, 0},
        {0.56, 1.125, 0.989884, -1, -1, 0, -1, -1, 0},
        {0.555, 1.145, 0.99464, -1, -1, 0, -1, -1, 0},
        {0.56, 1.145, 0.994009, -1, -1, 0, -1, -1, 0},
        {0.565, 1.145, 0.992529, -1, -1, 0, -1, -1, 0},
        {0.575, 1.145, 0.988776, -1, -1, 0, -1, -1, 0},
        {0.585, 1.15, 0.983986, -1, -1, 0, -1, -1, 0},
        {0.605, 1.145, 0.966159, -1, -1, 0, -1, -1, 0},
        {0.625, 1.155, 0.944338, -1, -1, 0, -1, -1, 0},
        {0.65, 1.16, 0.890528, -1, -1, 0, -1, -1, 0},
        {0.69, 1.17, 0.798948, -1, -1, 0, -1, -1, 0},
        {0.725, 1.185, 0.621268, -1, -1, 0, -1, -1, 0}
    };

int pid_pbpb30_TShine() {

  vector<float> rvmom{};
  rvmom.insert(rvmom.begin(), vmom.rbegin(), vmom.rend());

  assert(vmom.size() == pos.size());

  auto pid_getter = new Pid::CutGGetter;
  {
    // positive pions
    vector<double> vxLo;
    vector<double> vyLo;
    vector<double> vxHi;
    vector<double> vyHi;

    int ip = 0;
    for (auto p : rvmom) {
      auto dedxLo = pos[ip][0];
      auto dedxHi = pos[ip][1];
      ++ip;

      if (dedxHi <= dedxLo) {
        // skip this point
        cout << "Skip!" << endl;
        continue;
      }

      if (dedxLo < 0 || dedxHi < 0) {
        // skip this point
        cout << "Skip!" << endl;
        continue;
      }
      cout << p << " " << dedxLo << " " << dedxHi << endl;
      vxLo.push_back(p);
      vyLo.push_back(dedxLo);
      vxHi.push_back(p);
      vyHi.push_back(dedxHi);
    }

    vxLo.insert(vxLo.end(), vxHi.rbegin(), vxHi.rend());
    vyLo.insert(vyLo.end(), vyHi.rbegin(), vyHi.rend());

    auto cutg = new TCutG("dEdx_pion", vxLo.size(), vxLo.data(), vyLo.data());
    cutg->SetLineWidth(3);
    cutg->SetLineColor(kRed);

    pid_getter->AddParticle(cutg, 211);
  }

  {
    // negative pions
    vector<double> vxLo;
    vector<double> vyLo;
    vector<double> vxHi;
    vector<double> vyHi;

    int ip = 0;
    for (auto p : rvmom) {
      p = -p;
      auto dedxLo = neg[ip][0];
      auto dedxHi = neg[ip][1];
      ++ip;

      if (dedxHi <= dedxLo) {
        // skip this point
        cout << "Skip!" << endl;
        continue;
      }

      if (dedxLo < 0 || dedxHi < 0) {
        // skip this point
        cout << "Skip!" << endl;
        continue;
      }
      cout << p << " " << dedxLo << " " << dedxHi << endl;
      vxLo.push_back(p);
      vyLo.push_back(dedxLo);
      vxHi.push_back(p);
      vyHi.push_back(dedxHi);
    }

    vxLo.insert(vxLo.end(), vxHi.rbegin(), vxHi.rend());
    vyLo.insert(vyLo.end(), vyHi.rbegin(), vyHi.rend());

    auto cutg = new TCutG("dEdx_pion_neg", vxLo.size(), vxLo.data(), vyLo.data());
    cutg->SetLineWidth(3);
    cutg->SetLineColor(kRed);

    pid_getter->AddParticle(cutg, -211);
  }

  {
    // protons
    vector<double> vxLo;
    vector<double> vyLo;
    vector<double> vxHi;
    vector<double> vyHi;

    int ip = 0;
    for (auto p : rvmom) {
      double dedxLo = pos[ip][3];
      double dedxHi = pos[ip][4];
      ++ip;

      if (dedxHi <= dedxLo) {
        // skip this point
        cout << "Skip!" << endl;
        continue;
      }

      if (dedxLo < 0 || dedxHi < 0) {
        // skip this point
        cout << "Skip!" << endl;
        continue;
      }

      cout << p << " " << dedxLo << " " << dedxHi << endl;
      vxLo.push_back(p);
      vyLo.push_back(dedxLo);
      vxHi.push_back(p);
      vyHi.push_back(dedxHi);
    }

    vxLo.insert(vxLo.end(), vxHi.rbegin() + 1, vxHi.rend());
    vyLo.insert(vyLo.end(), vyHi.rbegin() + 1, vyHi.rend());

    auto cutg = new TCutG("dEdx_proton", vxLo.size(), vxLo.data(), vyLo.data());
    cutg->SetLineWidth(3);
    cutg->SetLineColor(kBlack);

    pid_getter->AddParticle(cutg, 2212);
  }

  pid_getter->Draw();

  return 0;
}
